# Security Policy

Welcome to our project! We are committed to maintaining the security of our project and take security issues very seriously. Our team promptly addresses any reported security vulnerabilities to ensure the safety and integrity of our project.

## Reporting Security Issues

Should you discover a security vulnerability or encounter any security-related issue in our project, we encourage you to report it to us immediately with the following methods:

- Email: [bmwu-support@lamda.nju.edu.cn](mailto:bmwu-support@lamda.nju.edu.cn)

When reporting an issue, kindly include as much detail as possible:

- **Description of the Issue**: Clearly describe what you have encountered.
- **Scope of the Impact**: Assess how the issue affects the project or its users.
- **Steps to Reproduce**: Provide a step-by-step guide to replicate the issue.
- **Supporting Material**: Attach any relevant screenshots, example code, or other materials that could aid in understanding the issue.

## Security Issue Handling Process

Upon receiving a report of a security issue, we will:

1. Promptly validate the reported issue to confirm its validity.
2. Once confirmed, our team will diligently work towards resolving the issue as swiftly as possible.
3. After resolving the issue, we will release a security advisory in accordance with our update schedule.

## Acknowledgement of Contributions

We deeply value the community's efforts in helping us maintain the security of our project. Therefore, we are committed to acknowledging the contributions of those who report security issues responsibly. We will recognize contributors in our advisories and public communications related to the security issue they helped address, respecting their privacy and confidentiality preferences.

Thank you for your support in keeping our project secure. Your vigilance, responsible reporting, and contributions are greatly appreciated and play a vital role in our continuous effort to improve security.
